import bpy
from bpy.props import StringProperty, CollectionProperty, BoolProperty, IntProperty


class AISTUDIO_UL_EnumManager(bpy.types.UIList):
    def draw_item(
        self,
        context,
        layout,
        data,
        item,
        icon: int,
        active_data,
        active_property: str,
        index: int = 0,
        flt_flag: int = 0,
    ):
        # split = layout.split(factor=0.2)
        # split.label(text="Index: %d" % (index))
        split = layout.split(factor=0.9)
        split.prop(item, "prompt", text="", emboss=False)
        op = split.operator(
            "aistudio.set_prompt", text="", emboss=False, icon="TRIA_RIGHT"
        )
        op.index = index


class AISTUDIO_GeneratedItem(bpy.types.PropertyGroup):
    id_: IntProperty(name="ID")  # type: ignore
    name: StringProperty(name="Name")  # type: ignore
    prompt: StringProperty(name="Prompt")  # type: ignore
    image: StringProperty(name="Image")  # type: ignore
    title: StringProperty(name="Title")  # type: ignore
    model_url: StringProperty(name="Url")  # type: ignore
    model_thumbnail: StringProperty(name="Thumbnail")  # type: ignore
    is_remeshed: BoolProperty(name="Remeshed", default=False)  # type: ignore
    format: StringProperty(name="Format")  # type: ignore
    is_3d: BoolProperty(name="3D", default=False)  # type: ignore
    task_id: StringProperty(name="Task ID")  # type: ignore
    created_at: StringProperty(name="Created")  # type: ignore
    filepath: StringProperty(name="filepath", subtype="FILE_PATH")  # type: ignore
    is_favorite: BoolProperty(name="Favorite")  # type: ignore


class AISTUDIO_Properties(bpy.types.PropertyGroup):


    api_key: StringProperty(
        name="Api Key",
        default="",
    )  # type: ignore

    prompt: StringProperty(name="Prompt")  # type: ignore

    image_path: StringProperty(name="Image", subtype="FILE_PATH", default="")  # type: ignore

    generations: CollectionProperty(type=AISTUDIO_GeneratedItem, name="generations")  # type: ignore

    active_idx: IntProperty(name="Active", default=0, min=0)  # type: ignore

    is_loading: BoolProperty(name="is_loading", default=False)  # type: ignore

    loading_message: StringProperty(name="loading_message", default="")  # type: ignore

    out_of_tokens: StringProperty(name="Link:", default="https://3daistudio.com/#pricing")

